// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S142_ExtendDetachedAuthorities.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S142_ExtendDetachedAuthorities extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int extendAuth = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\1\2\0\2\1"+
    "\1\0\1\5\12\6\1\7\1\10\5\0\1\11\1\12"+
    "\1\13\1\14\1\15\2\16\1\17\1\20\1\16\1\21"+
    "\1\22\1\23\1\24\1\16\1\25\2\16\1\26\1\27"+
    "\1\30\1\16\1\31\1\16\1\32\1\16\1\33\1\0"+
    "\1\34\1\0\1\35\1\0\1\36\1\37\1\40\1\41"+
    "\1\42\2\0\1\43\1\44\1\0\1\45\1\46\1\47"+
    "\1\50\1\0\1\51\2\0\1\52\1\53\1\54\1\0"+
    "\1\55\1\0\1\56\266\0\2\44\115\0\1\52\u0182\0"+
    "\1\1\20\0\2\1\u0115\0\1\45\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\47\0\1\5"+
    "\66\0\1\6\12\0\1\5\1\0\1\7\16\0\1\10"+
    "\43\0\1\11";

  private static int [] zzUnpackAction() {
    int [] result = new int[179];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\57\0\136\0\215\0\274\0\215\0\353\0\215"+
    "\0\u011a\0\u0149\0\u0178\0\u01a7\0\u01d6\0\u0205\0\u0234\0\u0263"+
    "\0\u0292\0\u02c1\0\u02f0\0\215\0\u031f\0\u034e\0\u037d\0\u03ac"+
    "\0\u03db\0\u040a\0\u0439\0\u0468\0\u0497\0\u04c6\0\u04f5\0\u0524"+
    "\0\u0553\0\u0582\0\u05b1\0\u05e0\0\u060f\0\u063e\0\u066d\0\u069c"+
    "\0\u06cb\0\u06fa\0\u0729\0\u0758\0\u0787\0\u07b6\0\u07e5\0\u0814"+
    "\0\u0843\0\u0872\0\u08a1\0\u08d0\0\u08ff\0\u092e\0\u095d\0\u098c"+
    "\0\u09bb\0\u09ea\0\u0a19\0\215\0\u0a48\0\u0a77\0\u0aa6\0\u0ad5"+
    "\0\u0b04\0\u0b33\0\u0b62\0\u0b91\0\u0bc0\0\u0bef\0\u0c1e\0\u0c4d"+
    "\0\u0c7c\0\u0cab\0\u0cda\0\u0d09\0\u0d38\0\u0d67\0\u0d96\0\u0dc5"+
    "\0\u0df4\0\u0e23\0\u0e52\0\u0e81\0\u0eb0\0\u0edf\0\u0f0e\0\u0f3d"+
    "\0\u0f6c\0\u0f9b\0\u0fca\0\u0ff9\0\u1028\0\u1057\0\u1086\0\u10b5"+
    "\0\u10e4\0\u1113\0\u1142\0\u1171\0\u11a0\0\u11cf\0\u11fe\0\u122d"+
    "\0\u125c\0\u128b\0\u12ba\0\u12e9\0\u1318\0\u1347\0\u1376\0\u13a5"+
    "\0\u13d4\0\u1403\0\215\0\u1432\0\u1461\0\u1490\0\u14bf\0\u14ee"+
    "\0\u151d\0\u154c\0\u157b\0\u15aa\0\u15d9\0\u1608\0\u1608\0\215"+
    "\0\u1637\0\u1666\0\u1695\0\u16c4\0\u16f3\0\u1722\0\u1751\0\u1780"+
    "\0\u17af\0\u17de\0\u180d\0\u183c\0\u186b\0\u189a\0\215\0\u18c9"+
    "\0\u18f8\0\u1927\0\u1956\0\u1985\0\u19b4\0\u19e3\0\u1a12\0\u1a41"+
    "\0\u1a70\0\u1a9f\0\u1ace\0\u1afd\0\u1b2c\0\u1b5b\0\u1b8a\0\u1bb9"+
    "\0\u1be8\0\u1c17\0\u1c46\0\u1c75\0\u1ca4\0\u1cd3\0\u1d02\0\u1d31"+
    "\0\u1d60\0\u1d8f\0\u1dbe\0\u1ded\0\u1e1c\0\u1e4b\0\u1e7a\0\u1ea9"+
    "\0\u1ed8\0\u1f07\0\215";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[179];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\33\4\1\5\23\4\33\6\1\7\23\6\33\10\1\11"+
    "\23\10\101\0\1\12\23\0\1\12\15\0\1\13\73\0"+
    "\1\14\23\0\1\14\31\0\1\15\23\0\1\15\33\0"+
    "\1\16\23\0\1\16\31\0\1\17\23\0\1\17\35\0"+
    "\1\20\23\0\1\20\27\0\1\21\23\0\1\21\35\0"+
    "\1\22\23\0\1\22\15\0\1\23\73\0\1\24\23\0"+
    "\1\24\15\0\1\25\60\0\2\26\1\27\17\26\2\0"+
    "\1\26\2\0\1\30\27\0\2\31\1\32\7\31\1\33"+
    "\7\31\2\0\1\31\2\0\1\34\6\0\1\35\16\0"+
    "\1\36\1\0\22\26\2\0\1\26\30\0\1\36\1\0"+
    "\11\26\1\37\10\26\2\0\1\26\10\0\1\40\32\0"+
    "\1\40\23\0\1\40\17\0\1\41\1\0\22\31\2\0"+
    "\1\31\30\0\1\41\1\0\7\31\1\42\1\31\1\43"+
    "\10\31\2\0\1\31\6\0\1\44\1\0\1\45\17\0"+
    "\1\41\1\0\17\31\1\46\2\31\2\0\1\31\16\0"+
    "\1\47\22\0\1\44\1\0\1\45\21\0\1\44\1\0"+
    "\1\45\40\0\1\47\23\0\1\47\2\0\2\36\2\0"+
    "\3\36\1\50\23\36\2\0\22\36\7\0\1\36\1\0"+
    "\22\26\2\0\1\51\56\0\1\52\21\0\2\41\2\0"+
    "\3\41\1\53\23\41\2\0\22\41\7\0\1\41\1\0"+
    "\16\31\1\54\3\31\2\0\1\31\15\0\1\55\12\0"+
    "\1\41\1\0\22\31\2\0\1\56\50\0\1\55\23\0"+
    "\1\55\40\0\1\57\30\0\1\41\1\0\13\31\1\60"+
    "\6\31\2\0\1\31\12\0\1\61\32\0\1\61\23\0"+
    "\1\61\14\0\1\62\57\0\1\36\1\0\3\26\1\63"+
    "\16\26\2\0\1\26\3\0\1\64\31\0\1\64\24\0"+
    "\1\64\23\0\1\65\57\0\1\41\1\0\21\31\1\66"+
    "\2\0\1\31\20\0\1\67\32\0\1\67\23\0\1\67"+
    "\7\0\1\41\1\0\3\31\1\70\16\31\2\0\1\31"+
    "\3\0\1\71\31\0\1\71\24\0\1\71\24\0\1\41"+
    "\1\0\7\31\1\72\12\31\2\0\1\31\6\0\1\73"+
    "\32\0\1\73\23\0\1\73\20\0\1\62\25\0\1\74"+
    "\31\0\1\36\1\0\4\26\1\75\15\26\2\0\1\26"+
    "\4\0\1\76\31\0\1\76\24\0\1\76\22\0\1\65"+
    "\25\0\1\77\31\0\1\100\1\0\22\31\2\0\1\31"+
    "\30\0\1\100\56\0\1\41\1\0\4\31\1\101\15\31"+
    "\2\0\1\31\4\0\1\102\31\0\1\102\24\0\1\102"+
    "\23\0\1\41\1\0\2\31\1\103\17\31\2\0\1\31"+
    "\2\0\1\104\31\0\1\104\24\0\1\104\25\0\1\36"+
    "\1\0\16\26\1\105\3\26\2\0\1\26\15\0\1\106"+
    "\32\0\1\106\23\0\1\106\3\0\33\107\1\0\23\107"+
    "\2\100\2\0\3\100\1\110\23\100\2\0\22\100\7\0"+
    "\1\41\1\0\16\31\1\111\3\31\2\0\1\31\15\0"+
    "\1\112\32\0\1\112\23\0\1\112\12\0\1\41\1\0"+
    "\7\31\1\113\12\31\2\0\1\31\6\0\1\114\32\0"+
    "\1\114\23\0\1\114\21\0\1\36\1\0\1\115\21\26"+
    "\2\0\1\26\1\116\31\0\1\116\24\0\1\116\20\0"+
    "\33\107\1\117\23\107\6\0\1\120\57\0\1\41\1\0"+
    "\1\121\21\31\2\0\1\31\1\122\31\0\1\122\24\0"+
    "\1\122\27\0\1\41\1\0\14\31\1\123\5\31\2\0"+
    "\1\31\13\0\1\124\32\0\1\124\23\0\1\124\14\0"+
    "\1\36\1\0\2\26\1\125\17\26\2\0\1\26\2\0"+
    "\1\126\31\0\1\126\24\0\1\126\23\0\1\127\57\0"+
    "\1\120\25\0\1\130\31\0\1\41\1\0\2\31\1\131"+
    "\17\31\2\0\1\31\2\0\1\132\31\0\1\132\24\0"+
    "\1\132\25\0\1\41\1\0\1\133\21\31\2\0\1\31"+
    "\1\134\31\0\1\134\24\0\1\134\27\0\1\36\1\0"+
    "\6\26\1\135\13\26\2\0\1\26\5\0\1\136\32\0"+
    "\1\136\23\0\1\136\35\0\1\137\23\0\1\137\10\0"+
    "\33\140\1\0\23\140\7\0\1\41\1\0\6\31\1\141"+
    "\13\31\2\0\1\31\5\0\1\142\32\0\1\142\23\0"+
    "\1\142\22\0\1\41\1\0\11\31\1\143\10\31\2\0"+
    "\1\31\10\0\1\144\32\0\1\144\23\0\1\144\17\0"+
    "\1\36\1\0\4\26\1\145\15\26\2\0\1\26\4\0"+
    "\1\146\31\0\1\146\24\0\1\146\35\0\1\147\23\0"+
    "\1\147\11\0\33\140\1\150\23\140\7\0\1\41\1\0"+
    "\4\31\1\151\15\31\2\0\1\31\4\0\1\152\31\0"+
    "\1\152\24\0\1\152\23\0\1\41\1\0\7\31\1\42"+
    "\12\31\2\0\1\31\6\0\1\44\32\0\1\44\23\0"+
    "\1\44\21\0\1\36\1\0\3\26\1\153\16\26\2\0"+
    "\1\26\3\0\1\154\31\0\1\154\24\0\1\154\41\0"+
    "\1\155\23\0\1\155\13\0\1\156\60\0\1\41\1\0"+
    "\3\31\1\157\16\31\2\0\1\31\3\0\1\160\31\0"+
    "\1\160\24\0\1\160\24\0\1\161\1\0\22\26\2\0"+
    "\1\26\30\0\1\162\103\0\1\163\44\0\1\164\23\0"+
    "\1\164\17\0\1\165\1\0\22\31\2\0\1\31\30\0"+
    "\1\165\47\0\2\161\2\0\3\161\1\166\23\161\2\0"+
    "\22\161\2\162\2\0\3\162\1\167\23\162\2\0\22\162"+
    "\21\0\1\170\23\0\1\170\11\0\2\165\2\0\3\165"+
    "\1\171\23\165\2\0\22\165\6\0\1\172\56\0\1\173"+
    "\74\0\1\174\23\0\1\174\14\0\1\175\56\0\1\172"+
    "\25\0\1\176\30\0\1\173\25\0\1\177\56\0\1\200"+
    "\30\0\1\175\25\0\1\201\22\0\33\202\1\0\23\202"+
    "\33\203\1\0\23\203\33\202\1\204\23\202\33\203\1\205"+
    "\23\203\5\0\1\206\56\0\1\207\73\0\1\210\23\0"+
    "\1\210\32\0\1\211\23\0\1\211\31\0\1\212\23\0"+
    "\1\212\32\0\1\213\23\0\1\213\35\0\1\214\23\0"+
    "\1\214\32\0\1\215\23\0\1\215\42\0\1\216\56\0"+
    "\1\217\23\0\2\216\1\0\1\220\26\0\1\221\1\0"+
    "\1\216\45\0\1\222\23\0\1\222\30\0\1\223\23\0"+
    "\1\223\22\0\1\224\24\0\1\224\40\0\1\225\23\0"+
    "\1\225\37\0\1\226\23\0\1\226\30\0\1\227\23\0"+
    "\1\227\33\0\1\230\23\0\1\230\14\0\1\231\57\0"+
    "\1\216\61\0\1\232\7\0\1\233\2\0\1\234\11\0"+
    "\1\232\6\0\1\233\2\0\1\234\24\0\1\235\23\0"+
    "\1\235\42\0\1\236\23\0\1\236\31\0\1\237\23\0"+
    "\1\237\32\0\1\240\23\0\1\240\27\0\1\241\23\0"+
    "\1\241\33\0\1\242\23\0\1\242\37\0\1\243\23\0"+
    "\1\243\20\0\1\244\23\0\1\244\43\0\1\154\23\0"+
    "\1\154\10\0\1\245\62\0\1\246\24\0\1\246\16\0"+
    "\2\245\2\0\3\245\1\247\23\245\2\0\22\245\20\0"+
    "\1\250\23\0\1\250\20\0\1\251\75\0\1\252\23\0"+
    "\1\252\13\0\1\251\25\0\1\253\33\0\1\254\24\0"+
    "\1\254\20\0\33\255\1\0\23\255\22\0\1\232\23\0"+
    "\1\232\10\0\33\255\1\256\23\255\5\0\1\257\73\0"+
    "\1\260\23\0\1\260\31\0\1\261\23\0\1\261\35\0"+
    "\1\262\23\0\1\262\42\0\1\263\22\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[7990];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\47\0\1\11\66\0\1\11\12\0\1\1\1\0"+
    "\1\11\16\0\1\11\43\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[179];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S142_ExtendDetachedAuthorities() { }
		
	private AnnotationEntity authEntity = null;
	
	private String originalText = "";
	private int originalPosition = 0;



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S142_ExtendDetachedAuthorities(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 10: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 11: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}

			//Uscita
			
			addEntity(authEntity);
			
			yybegin(0);
		}
            }
          // fall through
          case 12: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 13: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 14: break;
          case 6:
            { if(offset == length) {

			//Uscita
			
			addEntity(authEntity);
					
			yypushback(yylength());
			yybegin(0);

		} else {
		
			AnnotationEntity retrievedEntity = retrieveEntity();
			
			offset += yylength();
			position += retrievedEntity.getText().length();
		}
            }
          // fall through
          case 15: break;
          case 7:
            { AnnotationEntity item = retrieveEntity();
		
		authEntity.addRelatedEntity(item);
		
		offset += yylength();
		position += item.getText().length();
            }
          // fall through
          case 16: break;
          case 8:
            { authEntity = retrieveEntity();
		
		authEntity.setText(originalText);
		authEntity.setPosition(originalPosition);
		
		offset += yylength();
		position += authEntity.getText().length();
            }
          // fall through
          case 17: break;
          case 9:
            { authEntity = null;
	
	originalText = Util.removeAllAnnotations(yytext());
	originalPosition = position;
	
	start(null, extendAuth, false, false);
            }
          // fall through
          case 18: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S142_ExtendDetachedAuthorities [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S142_ExtendDetachedAuthorities scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S142_ExtendDetachedAuthorities(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
